%define pubdicrhver 20020225
%define zipcodever 20020204
%define cannadicver 0.93a

Summary: A Japanese character set input system.
Name: Canna
Version: 3.5b2
Release: 60
License: Distributable
Group: System Environment/Libraries
URL: http://www.nec.co.jp/japanese/product/computer/soft/canna/
Source0: ftp://ftp.nec.co.jp/pub/Canna/Canna35/Canna35b2.tar.bz2
Source1: http://cannadic.oucrc.org/cannadic-%{cannadicver}.tar.gz
Source2: pubdic-bonobo-%{pubdicrhver}.tar.bz2
Source3: http://www.coolbrain.net/dl/shion/shion.tar.gz
Source4: http://bonobo.gnome.gr.jp/~nakai/canna/zipcode-%{zipcodever}.tar.bz2
Source20: canna.init
Source21: dot-canna
Patch0: Canna-3.5b2.conf.patch
Patch1: Canna-3.5b2.Imakefile.patch
Patch2: Canna-3.5b2-glibc.patch
Patch3: Canna-3.5b2.noch.patch
Patch4: Canna-3.5b2-stdin.patch
Patch5: Canna-3.5b2-locale.patch
Patch6: Canna-3.5b2-bcopy.patch
# Patch7: Canna-3.5b2-fhs.patch
Patch8: canna-security.patch
Patch9: Canna-3.5b2-hosts.canna-fix.patch
Patch11: Canna-3.5b2-uidgid.canna-fix.patch
Patch12: Canna-3.5b2-proto.patch
Patch13: Canna-3.5b2-ia64.patch
Patch14: Canna35b2-user.patch
Patch15: Canna35b2-unix.patch
Patch16: Canna35b2-dicsdir.patch
## some dictionaries were ported from SKK-JISYO.*
Patch17: skk-dictionaries.patch
Patch18: Canna-3.5b2-cannadic.patch
Patch19: Canna-3.5b2-shion.patch
Patch20: Canna-3.5b2-iroha.patch
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
Prereq: /sbin/chkconfig, /etc/services, /bin/grep, /bin/cp
BuildPrereq: XFree86-devel,cpp,gawk

%description
Canna provides a user interface for inputting Japanese characters.
Canna supports Nemacs (Mule), kinput2, and canuum. All of these tools
can then use a single customization file, Romaji-to-Kana conversion
rules and dictionaries, and input Japanese in the same way. Canna
automatically supports Kana-to-Kanji conversions; the conversions are
based on a client-server model.

%package devel
Summary: Header file and library for developing programs which use Canna.
Group: Development/Libraries
Requires: Canna-libs >= %{version}-%{release}

%package libs
Summary: The runtime library for Canna.
Group: System Environment/Libraries

%description devel
The Canna-devel package contains the development files needed to build
programs that will use the Canna Japanese character input system.

%description libs
The Canna-libs package contains the runtime library for running
programs with the Canna Japanese input system.

%prep
%setup -q -c -a 1 -a 2 -a 3 -a 4
%patch0 -p0
%patch1 -p0
%patch4 -p0
if [ -f /lib/libc-2* ]; then
%patch2 -p0
fi
#set `/usr/bin/id`
#if [ X$1 != "Xuid=0(root)" ]; then
%patch3 -p0
#fi
%patch5 -p0
%patch6 -p0
# %patch7 -p1 -b .fhs
%patch8 -p0 -b .security
%patch9 -p0 -b .hostscanna
%patch11 -p0 -b .uid
%patch12 -p0 -b .proto
%patch13 -p0 -b .ia64
%patch14 -p0 -b .user
%patch15 -p0 -b .unix
%patch16 -p0 -b .dicsdir
%patch17 -p0 -b .skk
%patch18 -p0 -b .cannadic
%patch19 -p0 -b .shion
%patch20 -p0 -b .iroha

cat $RPM_BUILD_DIR/Canna-3.5b2/zipcode-%{zipcodever}/zipcode.t \
	$RPM_BUILD_DIR/Canna-3.5b2/zipcode-%{zipcodever}/jigyosyo.t | sort \
	> $RPM_BUILD_DIR/Canna-3.5b2/Canna35b2/dic/ideo/words/zipcode.t

cat $RPM_BUILD_DIR/Canna-3.5b2/pubdic-bonobo/*.p | sort >> \
	$RPM_BUILD_DIR/Canna-3.5b2/Canna35b2/dic/ideo/pubdic/y.p

%{__rm} -fr $RPM_BUILD_ROOT
%{__mkdir_p} $RPM_BUILD_ROOT/usr/X11R6
if [ -d /usr/X11R6.1 ]; then
	%{__ln_s} -f $RPM_BUILD_ROOT/usr/X11R6 $RPM_BUILD_ROOT/usr/X11R6.1
fi
if [ -d /usr/X11R6.3 ]; then
	%{__ln_s} -f $RPM_BUILD_ROOT/usr/X11R6 $RPM_BUILD_ROOT/usr/X11R6.3
fi
%{__mkdir_p} $RPM_BUILD_ROOT/usr/X11R6/bin
%{__mkdir_p} $RPM_BUILD_ROOT/usr/X11R6/man/man1


%build
cd Canna35b2
xmkmf
make Makefile
( cd lib/canna; xmkmf; make sglobal.h )
make canna
cd ..

cd cannadic-%{cannadicver}
for i in $RPM_BUILD_DIR/Canna-3.5b2/Canna35b2/cmd/*; do \
if [ -d $i ]; then \
  export PATH=$PATH:$i; \
fi \
done;
export RPM_CANNAIDEO_DIR=$RPM_BUILD_DIR/Canna-3.5b2/Canna35b2/dic/ideo
export RPM_CANNACMD_DIR=$RPM_BUILD_DIR/Canna-3.5b2/Canna35b2/cmd
sed 's/crxdic/crxdic -D $RPM_CANNAIDEO_DIR\/grammar\/cnj.bits/' \
	$RPM_CANNACMD_DIR/mkbindic/mkbindic > \
	$RPM_CANNACMD_DIR/mkbindic/mkbindic.tmp
chmod +x $RPM_CANNACMD_DIR/mkbindic/mkbindic.tmp
$RPM_CANNACMD_DIR/mkbindic/mkbindic.tmp -m gcanna.t
$RPM_CANNACMD_DIR/mkbindic/mkbindic.tmp -s gcannaf.t
cd ..

cd shion
$RPM_CANNACMD_DIR/mkbindic/mkbindic.tmp basho.ctd;
$RPM_CANNACMD_DIR/mkbindic/mkbindic.tmp keisan.ctd;
$RPM_CANNACMD_DIR/mkbindic/mkbindic.tmp pub.ctd;
$RPM_CANNACMD_DIR/mkbindic/mkbindic.tmp scien.ctd;
$RPM_CANNACMD_DIR/mkbindic/mkbindic.tmp sup.ctd;
cd ..

%install
if  ! %{__grep} -q '^canna:' /etc/passwd
then
    /usr/sbin/useradd -c "Canna Service User" -r \
      -s /bin/false -u 39 -d /var/lib/canna canna 2>/dev/null || :
fi
cd Canna35b2
make DESTDIR=$RPM_BUILD_ROOT install
make DESTDIR=$RPM_BUILD_ROOT MANDIR=%{_mandir} install.man
cd ..

(
cd $RPM_BUILD_ROOT%{_mandir}/ja;
mv man1x man1;
mv man3x man3;
cd man1;
for I in *; do sed -e 's/man1x/man1/g' < $I > $I-; mv -f $I- $I; done;
cd ../man3;
for I in *; do sed -e 's/man3x/man3/g' < $I > $I-; mv -f $I- $I; done
)

cd Canna35b2
%{__mv} misc/manual.sed .
%{__rm} -fr misc
%{__mkdir} misc
%{__mv} manual.sed misc
cd ..

cd cannadic-%{cannadicver}
%{__mkdir_p} $RPM_BUILD_ROOT/var/lib/canna/dic/canna
%{__install} -m 644 gcanna*.c[bl]d \
	$RPM_BUILD_ROOT/var/lib/canna/dic/canna
cd ..

cd shion
%{__install} -m 644 basho.cld basho.cbd kaom.ctd keisan.cld keisan.cbd \
	pub.cld pub.cbd scien.cld scien.cbd sup.cld sup.cbd \
	$RPM_BUILD_ROOT/var/lib/canna/dic/canna
cd ..

%{__mkdir_p} $RPM_BUILD_ROOT/etc/rc.d/init.d
%{__mkdir_p} $RPM_BUILD_ROOT/etc/skel
%{__install} -m 755 %SOURCE20 $RPM_BUILD_ROOT/etc/rc.d/init.d/canna
%{__cp} %SOURCE21 $RPM_BUILD_ROOT/etc/skel/.canna
## chmod 755 $RPM_BUILD_ROOT/etc/rc.d/init.d/canna

cat > $RPM_BUILD_ROOT/etc/hosts.canna << EOF
unix
localhost
EOF

cat > $RPM_BUILD_ROOT/var/lib/canna/cannahost << EOF
unix
EOF

for bin in addwords cpdic delwords lsdic mkdic mvdic rmdic syncdic ; do
	ln -sf catdic $RPM_BUILD_ROOT/usr/bin/${bin}
done
ln -sf ../bin/catdic $RPM_BUILD_ROOT/usr/sbin/cannakill


%clean
rm -fr $RPM_BUILD_ROOT


%post
if ! grep -q canna /etc/services
then
	echo "canna		5680/tcp" >>/etc/services
fi
/sbin/chkconfig --add canna
/sbin/ldconfig


%preun
if [ "$1" = "0" ]; then
    /sbin/service canna stop > /dev/null 2>&1 || :
    /sbin/chkconfig --del canna
fi


%postun
if [ "$1" -ge "1" ]; then
    /sbin/service canna condrestart >/dev/null 2>&1 || :
fi
/sbin/ldconfig


%post libs
/sbin/ldconfig


%postun libs
/sbin/ldconfig


%files
%defattr (-,root,root)
%doc Canna35b2/CHANGES.jp Canna35b2/INSTALL Canna35b2/INSTALL.jp
%doc Canna35b2/README Canna35b2/README.jp Canna35b2/WHATIS Canna35b2/WHATIS.jp
%doc Canna35b2/Canna.conf Canna35b2/doc Canna35b2/misc
%config /etc/rc.d/init.d/canna
%config /etc/skel/.canna
%config(noreplace) /etc/hosts.canna
%config(noreplace) /var/lib/canna/cannahost
%{_bindir}/*
%{_mandir}/ja/man1/*
%defattr (0755,bin,bin)
%{_sbindir}/cannaserver
%{_sbindir}/cannakill
%defattr (-,bin,bin)
/var/lib/canna
/var/log/canna


%files devel
%defattr (-,root,root)
%{_includedir}/canna/
%{_mandir}/ja/man3/*
%{_libdir}/libRKC.a
%{_libdir}/libRKC.so
%{_libdir}/libRKC16.a
%{_libdir}/libRKC16.so
%{_libdir}/libcanna.a
%{_libdir}/libcanna.so
%{_libdir}/libcanna16.a
%{_libdir}/libcanna16.so


%files libs
%defattr (-,root,root)
%{_libdir}/libRKC.so.1.0.0
%{_libdir}/libRKC.so.1.0
%{_libdir}/libRKC16.so.1.0.0
%{_libdir}/libRKC16.so.1.0
%{_libdir}/libcanna.so.1.0.0
%{_libdir}/libcanna.so.1.0
%{_libdir}/libcanna16.so.1.0.0
%{_libdir}/libcanna16.so.1.0

%changelog
* Wed Jan 30 2002 Yukihiro Nakai <ynakai@redhat.com> 3.5b2-58
- Update zipcode dic
- Update pubdic-bonobo

* Mon Jan 21 2002 Yukihiro Nakai <ynakai@redhat.com> 3.5b2-56
- Update pubdic-bonobo(renamed from pubdic-redhat)

* Sat Jan 12 2002 Yukihiro Nakai <ynakai@redhat.com> 3.5b2-55
- Minor fix for shion
- Update cannadic to 0.93

* Wed Jan  9 2002 Yukihiro Nakai <ynakai@redhat.com> 3.5b2-52
- %%doc fix
- Add pubdic-redhat
- Add dictionary 'shion'

* Sun Jan  6 2002 Yukihiro Nakai <ynakai@redhat.com> 3.5b2-51
- Add cannadic, GPL dictionary

* Thu Aug 30 2001 Yukihiro Nakai <ynakai@redhat.com>
- Set -inet option by default in canna init script and add localhost
  to hosts.canna. It affects to tamago/emacs problem(#52886)

* Wed Aug 29 2001 Yukihiro Nakai <ynakai@redhat.com>
- Apply patch3 in all case

* Thu Aug 23 2001 Jens Petersen <petersen@redhat.com> - 3.5b2-48
- Add defattr before /var/lib/canna, so that files therein not made executable.

* Wed Aug 22 2001 SATO Satoru <ssato@redhat.com> - 3.5b2-47
- cleaned up SPEC (remove meaningless 'Prefix:' tag, use macros, etc.)
- added BuildPrereq: XFree86-devel (xmkmf)
- added some dictionaries ported from skk (#52248)
- added %%config(noreplace) /var/lib/canna/cannahost

* Tue Aug 21 2001 Yukihiro Nakai <ynakai@redhat.com> - 3.5b2-46
- Build fix with (#52088)

* Wed Aug 15 2001 Jens Petersen <petersen@redhat.com> - 3.5b2-45
- Added patch by Ishikawa to make cannaserver listen only on a unix domain
  socket by default (#33420) and create "/var/lib/canna/cannahost" to help
  kinput2 find it.
- Added fix from Ishikawa for "typo" in malloc call in lib/RK/dd.c. 

* Tue Aug  9 2001 Yukihiro Nakai <ynakai@redhat.com> - 3.5b2-44
- Off the S bit (#13135)

* Sun Jun 24 2001 Elliot Lee <sopwith@redhat.com>
- Bump release + rebuild.

* Mon Apr 23 2001 Yukihiro Nakai <ynakai@redhat.com>
- Add complete ia64 patch

* Tue Apr 17 2001 Bill Nottingham <notting@redhat.com>
- build on ia64 so that dependencies work

* Tue Feb  6 2001 Matt Wilson <msw@redhat.com>
- changed requires on Canna-devel to require Canna-libs, not Canna

* Tue Feb  6 2001 Trond Eivind Glomsrd <teg@redhat.com>
- Display OK or FAILED from initscript (#26111)

* Fri Jan 26 2001 Yukihiro Nakai <ynakai@redhat.com>
- More fix to reduce warning

* Fri Jan 26 2001 Yukihiro Nakai <ynakai@redhat.com>
- Capitalize summary
- Add Requires to Canna-devel
- Minor fix for %%files

* Wed Jan 24 2001 Adrian Havill <havill@redhat.com>
- changed dangerous suid bin/bin uid/gid of server to canna/canna

* Tue Jan 23 2001 Yukihiro Nakai <ynakai@redhat.com>
- Update canna.init (teg@redhat.com>

* Tue Jan 23 2001 Yukihiro Nakai <ynakai@redhat.com>
- Add defattr
- Add post and postun for -libs to ldconfig

* Mon Jan 22 2001 Yukihiro Nakai <ynakai@redhat.com>
- Split the runtime library
- bzip2

* Fri Jan 19 2001 Yukihiro Nakai <ynakai@redhat.com>
- Disable IA64 patch. It seems to cause serious problem.
  (Such IA64 fix is not needed with the newer compiler?)

* Fri Jan 19 2001 Matt Wilson <msw@redhat.com>
- use -DCANNA_WCHAR (revert the the part of the ia64 patch that disables
  -DCANNA_WCHAR

* Tue Dec 19 2000 Yukihiro Nakai <ynakai@redhat.com>
- Add IA64 patch (Not complete)

* Wed Sep 13 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- spcfile typo fix (doc-canna -> dot-canna)

* Wed Sep 13 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- add /etc/skel/.canna

* Thu Sep 12 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- fix initscript

* Mon Sep 11 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- chown bin.bin /usr/sbin/{cannaserver,cannakill},/var/lib/canna
  and /var/log/canna

* Mon Sep 11 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- hosts.canna read bug fix.

* Thu Sep  7 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- move back /etc/init.d -> /etc/rc.d/init.d

* Thu Aug 24 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- chmod +x /etc/init.d/canna

* Fri Aug  4 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- move /etc/rc.d/init.d -> /etc/init.d

* Thu Aug  3 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- rebuilt for RedHat 7.0.
- man directory ja_JP.UJIS -> ja
- Canna-3.5b2.conf.patch modified to install manpages to /usr/share/man
- remove Canna-3.5b2-fhs.patch to install manpages to /usr/share/man 

* Tue Jul 18 2000 Nalin Dahyabhai <nalin@redhat.com>
- fix syntax error in postun
- no need to remove the services entry in postun
- make all symlinks to catdic relative instead of absolute

* Fri Jul 14 2000 Bill Nottingham <notting@redhat.com>
- move initscript back

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Tue Jul 11 2000 Bill Nottingham <notting@redhat.com>
- don't run by default
- add buffer overflow patch
- add configuration that should in theory only accept connections
  from localhost or unix socket

* Mon Jun 26 2000 Preston Brown <pbrown@redhat.com>
- initscript to /etc/init.d, and updated for new initscript stds.

* Mon Jun 19 2000 Preston Brown <pbrown@redhat.com>
- FHS paths

* Mon Jun 12 2000 Matt Wilson <msw@redhat.com>
- don't redefine bcopy
- add defattr

* Sun Mar 26 2000 Chris Ding <cding@redhat.com>
- ja -> ja_JP.eucJP

* Tue Mar 21 2000 Chris Ding <cding@redhat.com>
- ja_JP.eucJP -> ja

* Thu Mar  9 2000 Matt Wilson <msw@redhat.com>
- build for 6.2, gzip manpages

* Sat Mar  4 2000 Chris Ding <cding@redhat.com>
- ja -> ja_JP.eucJP
- changed group

* Thu Oct 21 1999 Matt Wilson <msw@redhat.com>
- added prereq for grep and cp

* Wed Oct 20 1999 Matt Wilson <msw@redhat.com>
- added prereq for /sbin/chkconfig and /etc/services

* Tue Oct 12 1999 Matt Wilson <msw@redhat.com>
- fixed redirection path for 4 man pages

* Thu Oct  7 1999 Matt Wilson <msw@redhat.com>
- rebuilt against 6.1

* Thu Jun 24 1999 Japanese LinuxPPC Users' Group <jrpm@ppc.linux.or.jp>
- build against Linuxppc R5
- add Oe's stdin patch in Canna-3.5b2-3rh.src.rpm
- change canna.init and spec file for safty shutdown cannaserver. Thanks to Shoichiro Nagata.

* Sun May 30 1999 FURUSAWA,Kazuhisa <kazu@linux.or.jp>
- 4th Release for i386 (glibc2.1).
- Original Packager: Atsushi Yamagata <yamagata@plathome.co.jp>

* Fri Jan 22 1999 Atsushi Yamagata <yamagata@plathome.co.jp>
- 4th release
- changed installed directories (See Canna.conf and INSTALL.jp)
- added post-{un}install scripts for Canna and Canna-devel packages
- added URL, Distribution, Vendor, and Prefix tags

* Tue Nov 04 1997 Atsushi Yamagata <yamagata@jwu.ac.jp>
- 3rd release
- patched for glibc. Thanks Mr. Daisuke Sato <densuke@ga2.so-net.or.jp>
- divided the Canna packege into Canna and Canna-devel

* Sun Jul 27 1997 Atsushi Yamagata <yamagata@jwu.ac.jp>
- 2nd release

* Fri Jul 11 1997 Atsushi Yamagata <yamagata@jwu.ac.jp>
- 1st release

